Index: res/res_musiconhold.c
===================================================================
--- res/res_musiconhold.c	(revision 74108)
+++ res/res_musiconhold.c	(working copy)
@@ -898,6 +898,16 @@
 	return 0;
 }
 
+static struct mohclass *moh_getclass(char *class)
+{
+	struct mohclass *mohclass = NULL;
+
+	if (!ast_strlen_zero(class) && (!(mohclass = get_mohbyname(class))))
+		ast_log(LOG_WARNING, "No Class: %s\n", class);
+
+	return mohclass;
+}
+
 static void local_ast_moh_cleanup(struct ast_channel *chan)
 {
 	if (chan->music_state) {
@@ -906,20 +916,29 @@
 	}
 }
 
-static int local_ast_moh_start(struct ast_channel *chan, char *class)
+static int local_ast_moh_start(struct ast_channel *chan, char *classname)
 {
 	struct mohclass *mohclass;
+	char *class;
 
-	if (ast_strlen_zero(class))
+	ast_mutex_lock(&moh_lock);
+	if ((mohclass = moh_getclass(classname)))
+		class = classname;
+	else if ((mohclass = moh_getclass(chan->musicclass)))
 		class = chan->musicclass;
-	if (ast_strlen_zero(class))
+	else if ((mohclass = moh_getclass("default")))
 		class = "default";
-	ast_mutex_lock(&moh_lock);
-	mohclass = get_mohbyname(class);
+	else {
+		/* Last ditch effort */
+		if ((mohclass = mohclasses)) {
+			class = mohclass->name;
+			ast_log(LOG_WARNING, "Using first Music on Hold class in list: %s.\n", class);
+		}
+	}
 	ast_mutex_unlock(&moh_lock);
 
 	if (!mohclass) {
-		ast_log(LOG_WARNING, "No class: %s\n", (char *)class);
+		ast_log(LOG_WARNING, "Could not find acceptable Music on Hold class, ending Music on Hold.\n");
 		return -1;
 	}
 
